// BasisView.h : interface of the CBasisView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_BASISVIEW_H__54CD01D1_4540_11D1_B242_0000C09B5CBE__INCLUDED_)
#define AFX_BASISVIEW_H__54CD01D1_4540_11D1_B242_0000C09B5CBE__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#define CONNECTION_TIMEOUT 5
#define SERVER_TIMEOUT		4

#define CONNECTION_TIMER	6
#define AGENT_TIMER			7
#define TIMEOUT_TIMER		8

class CBasisDoc;

class CBasisView : public CEditView
{
protected: // create from serialization only
	CBasisView();
	DECLARE_DYNCREATE(CBasisView)

// Attributes
public:
	BOOL	m_bNoGraphics;
	BOOL	m_bTimerRunning;
	int	m_iTimerID;
	BOOL	m_bAgentRunning;
	int	m_iAgentTimerID;
	int	m_iTimeoutTimerID;
	BOOL	m_bReceivedData;

// Operations
public:
	CBasisDoc*	GetDocument();

	void	Message(LPCTSTR lpszMessage, BOOL bFromNetwork);
	void	SetNoGraphics(BOOL val) { m_bNoGraphics = val; };
	void	StartConnectionTimer();
	void	StopConnectionTimer();
	void	StartAgentTimer();
	void	StopAgentTimer();
	void	StartTimeoutTimer();
	void	StopTimeoutTimer();
	BOOL	GetRunning() { return m_bAgentRunning; };
	void	SetReceivedData(BOOL m_bVal = TRUE) { m_bReceivedData = TRUE; };

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBasisView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CBasisView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CBasisView)
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnDestroy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

#ifndef _DEBUG  // debug version in SoccermonitorView.cpp
inline CBasisDoc* CBasisView::GetDocument()
   { return (CBasisDoc*)m_pDocument; }
#endif


//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BASISVIEW_H__54CD01D1_4540_11D1_B242_0000C09B5CBE__INCLUDED_)
