#ifndef __NETWORK_HEADER_H
#define __NETWORK_HEADER_H

#include "resource.h"
//#include "TBehaviorNetwork.h"

typedef double (CObject::*PCallBackPerception)( void );
typedef void (CObject::*PCallBackAction)( double );

// defined when history of activation is needed (needs lots of space and time)
#define xACTIVATION_HISTORY
#define MAX_HISTORY 6000

#define xACTIVATION_DISTRIBUTION
#define NO_OF_SLOTS 10

// border to round values to zero or one when not using fuzzy
#define FUZZY_BORDER 0.5

// defined if fuzzy and is min, otherwise it is product
#define FUZZY_MIN_AND
// defined if fuzzy and is prod and take nth root of product
#define xFUZZY_SQRT_AND

// defines for Dorer2
// defined if bool propositions should be used
#define NO_TRANSFER_FUNCTION
#define NO_GOALTRACKING
#define NO_ACTION_PARAMETER
#define xNO_MULTIPLE_ACTIONS

// parameters for the networks
#define NO_OF_CONNECTION_TYPES		6
#define SITUATION_CONNECTION			0
#define GOAL_CONNECTION					1
#define PROTECTED_GOAL_CONNECTION	2
#define SUCCESSOR_CONNECTION			3
#define PREDECESSOR_CONNECTION		4
#define CONFLICTOR_CONNECTION			5

// strings for rules
#define NEWLINE "\r\n";
#define STRING_IF "if"
#define STRING_AND "and"
#define STRING_THEN "then"
#define STRING_EFFECT "effect"
#define STRING_NOT "not"
#define STRING_USING "using"
#define STRING_END_IF "endif"
#define STRING_GOAL "goal"
#define STRING_END_GOAL "endgoal"
// for blocksworld
#define STRING_GOALS "Goals"
#define STRING_END_GOALS "endgoals"
#define STRING_OBJECTS "Objects"
#define STRING_END_OBJECTS "endObjects"
#define STRING_ATTRIBUTES "attributes"
#define STRING_END_ATTRIBUTES "endAttributes"
#define STRING_INITIAL "initial"
#define STRING_END_INITIAL "endInitial"

#define MODULE_SIZE 5.0

#ifndef D_ZERO_P
	#define D_ZERO_P		0.0000001
#endif

#ifndef D_ZERO_N
	#define D_ZERO_N		-0.0000001
#endif


#endif //__NETWORK_HEADER_H