// TDorerNetwork.h: interface for the TDorerNetwork class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TDorerNetwork_H__F8B36941_B4DB_11D1_B242_0000C09B5CBE__INCLUDED_)
#define AFX_TDorerNetwork_H__F8B36941_B4DB_11D1_B242_0000C09B5CBE__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "TBehaviorNetwork.h"

class TCompetence;
class TNetworkView;
class TRuleView;

/*-----------------------------------------------------------------------------
Class   : TKnowledge
Date    : 08.01.98
-------------------------------------------------------------------------------
Base Class: CObject
Description: represents the knowledge of an agent containing the three levels
				 of cognition: 
				 cognitivly inpenetrable perception and action
				 competence modules
				 goals and goal management
				 implementation of Maes Agent Network Architecture (ANA) extended
				 to use multivalued propositions
-----------------------------------------------------------------------------*/
class DLL_CLASS TDorerNetwork : public TBehaviorNetwork
{
	public:
		TDorerNetwork(TNetworkView* pNView, TRuleView* pRView);
		virtual ~TDorerNetwork();

		// public methods
		virtual void	Initialize();
		virtual void	ParamsDialog();

		void				SetGoalTrackingOn(BOOL bVal);
		BOOL				GetGoalTrackingOn() const;
		void				SetUseFuzzyValues(BOOL bVal);
		BOOL				GetUseFuzzyValues() const;
		void				SetAdaptActivationAreaOn(BOOL bVal);
		BOOL				GetAdaptActivationAreaOn() const;

	protected:
		virtual TCompetence*	CreateNewCompetence();

};

#endif // !defined(AFX_TDorerNetwork_H__F8B36941_B4DB_11D1_B242_0000C09B5CBE__INCLUDED_)
