// TArea.cpp: implementation of the TArea class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Basis.h"
#include "TVector.h"
#include "TArea.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

double TArea::GetWidth()
{ 
	double width = m_tRightBottom.GetX() - m_tLeftTop.GetX();
	if (width < 0.0)
		return -width;
	else
		return width;
}

double TArea::GetLength()
{ 
	double length = m_tRightBottom.GetY() - m_tLeftTop.GetY();
	if (length < 0.0)
		return -length;
	else
		return length;
}

void TArea::Rotate(TVector& center, int angle)
{
	// translate origin
	TVector leftTop = m_tLeftTop - center;
	TVector rightBottom = m_tRightBottom - center;

	// rotate
	leftTop.Rotate(angle);
	rightBottom.Rotate(angle);

	// and retranslate origin
	m_tLeftTop = leftTop + center;
	m_tRightBottom = rightBottom + center;
}

void TArea::Rotate(int angle)
{
	// rotate
	m_tLeftTop.Rotate(angle);
	m_tRightBottom.Rotate(angle);
}

void TArea::Translate(TVector& trans)
{
	// rotate
	m_tLeftTop += trans;
	m_tRightBottom += trans;
}

BOOL TArea::InArea(TVector& point)
{
	// only works if rectangle is colinear to the axis !
	return (point.GetX() >= m_tLeftTop.GetX()) 
				&& (point.GetX() <= m_tRightBottom.GetX())
				&& (point.GetY() >= m_tLeftTop.GetY()) 
				&& (point.GetX() <= m_tRightBottom.GetY());
}
