// TDirection.cpp: implementation of the TDirection class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Basis.h"
#include "TDirection.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

void TDirection::CheckRange()
{
	if (m_iDirection == NOT_EXISTING)
		return;
	if (m_iDirection > 180)
		m_iDirection -= 360;
	else if (m_iDirection < -180)
		m_iDirection += 360;
}

TDirection TDirection::Abs(void)
{
	if (m_iDirection < 0)
		m_iDirection = - m_iDirection;
	return *this;
}

TDirection operator+ (int val1, TDirection& val2) 
{ 
	TDirection	dir(val1 + val2.GetDirection());
	dir.CheckRange();
	return TDirection(dir);
}

TDirection operator+ (TDirection& val1, int val2)
{ 
	TDirection	dir(val1.GetDirection() + val2);
	dir.CheckRange();
	return TDirection(dir);
}

TDirection operator+ (TDirection& val1, TDirection& val2)
{ 
	TDirection	dir(val1.GetDirection() + val2.GetDirection());
	dir.CheckRange();
	return TDirection(dir);
}

TDirection operator-(int val1, TDirection& val2)
{ 
	TDirection	dir(val1 - val2.GetDirection());
	dir.CheckRange();
	return TDirection(dir);
}

TDirection operator-(TDirection& val1, int val2)
{ 
	TDirection	dir(val1.GetDirection() - val2);
	dir.CheckRange();
	return TDirection(dir);
}

TDirection operator- (TDirection& val1, TDirection& val2)
{ 
	TDirection	dir(val1.GetDirection() - val2.GetDirection());
	dir.CheckRange();
	return TDirection(dir);
}

TDirection operator*(int val1, TDirection& val2)
{ 
	TDirection	dir(val1 * val2.GetDirection());
	dir.CheckRange();
	return TDirection(dir);
}

TDirection operator* (TDirection& val1, int val2)
{ 
	TDirection	dir(val1.GetDirection() * val2);
	dir.CheckRange();
	return TDirection(dir);
}


