// TScreenParams.h: interface for the TScreenParams class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TSCREENPARAMS_H__89781B21_5CDE_11D1_B242_0000C09B5CBE__INCLUDED_)
#define AFX_TSCREENPARAMS_H__89781B21_5CDE_11D1_B242_0000C09B5CBE__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000


#define DEFAULT_MIDX 300
#define DEFAULT_MIDY 100
#define DEFAULT_SCALEX 1.0
#define DEFAULT_SCALEY 3.0

/*-----------------------------------------------------------------------------
Class   : TScreenParams
Date    : 15.05.96
-------------------------------------------------------------------------------
Base Class: CObject

Description: controls the screen sccaling and translation
-----------------------------------------------------------------------------*/
class TScreenParams : public CObject  
{
	public:
		TScreenParams();
		virtual ~TScreenParams();

		int		GetMitteX(void) { return m_tMiddle.x; };
		int		GetMitteY(void) { return m_tMiddle.y; };
		double	GetScale(void) { return m_dScale; };
		void		SetScale(double scale) { m_dScale = scale; };
		double	GetAbsScale(void) { return m_dAbsScale; };
		void		SetAbsScale(double scale) { m_dAbsScale = scale; };
		void		SetSize(CSize size) { m_tSize = size; };
		CSize		GetSize() const { return m_tSize; };

		void		SetParams(int sizex, int sizey, double scalex);
		void		SetMid(int x, int y) { m_tMiddle.x = x; m_tMiddle.y = y; };
		void		Scale(double factor) { m_dScale *= factor; };

		void		SetViewAngle(int angle) { m_iViewAngle = angle; };
		int		GetViewAngle(void) const { return m_iViewAngle; };
		void		SetTopView(void);
		void		SetRelativeView(void);
		void		SetAbsoluteView(void);
		BOOL		IsTopView() { return m_bTopView; };
		BOOL		IsRelativeView() { return m_bRelativeView; };
		BOOL		IsAbsoluteView() { return m_bAbsoluteView; };
		void		SetTime(int time) { m_iTime = time; };
		int		GetTime(void) const { return m_iTime; };

		void		SetDrawDegreeOfFreeness(BOOL val) { m_bDrawDegreeOfFreeness = val; };
		BOOL		GetDrawDegreeOfFreeness(void) const { return m_bDrawDegreeOfFreeness; };
		void		SetDrawFutureBall(BOOL val) { m_bDrawFutureBall = val; };
		BOOL		GetDrawFutureBall(void) const { return m_bDrawFutureBall; };

		void		SetTranslation(CPoint point) { m_tTranslate = point; };
		void		Translate(CPoint point) { m_tTranslate += point; };
		CPoint	GetTranslation() { return m_tTranslate; };

		int		GetStretchX() { return m_iStretchX; };
		int		GetStretchY() { return m_iStretchY; };
		void		StretchX(int val) { m_iStretchX += val; if (m_iStretchX < 1) m_iStretchX = 1; };
		void		StretchY(int val) { m_iStretchY += val * 10; if (m_iStretchY < -60) m_iStretchY = -60; };

	private:
		double	m_dScale;
		double	m_dAbsScale;
		CSize		m_tSize;
		CPoint	m_tTranslate;
		CPoint	m_tMiddle;
		int		m_iStretchX;
		int		m_iStretchY;

		BOOL		m_bTopView;				// for TPerception
		BOOL		m_bRelativeView;		
		BOOL		m_bAbsoluteView;		
		BOOL		m_bDrawDegreeOfFreeness;
		BOOL		m_bDrawFutureBall;
		int		m_iViewAngle;			
		int		m_iTime;					

};

#endif // !defined(AFX_TSCREENPARAMS_H__89781B21_5CDE_11D1_B242_0000C09B5CBE__INCLUDED_)
