// TThisPlayer.h: interface for the TThisPlayer class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TTHISPLAYER_H__170267C1_E28F_11D2_A173_006008E88C8E__INCLUDED_)
#define AFX_TTHISPLAYER_H__170267C1_E28F_11D2_A173_006008E88C8E__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "TVisibleObject.h"

/*-----------------------------------------------------------------------------
Class   : TThisPlayer
Date    : 25.03.99
-------------------------------------------------------------------------------
Base Class: TPlayer

Description: holds the information for the agents perceptions
-----------------------------------------------------------------------------*/
class TThisPlayer : public TPlayer  
{
	public:
		TThisPlayer();
		virtual ~TThisPlayer();

		virtual void GetObjectText(CString& text) { text.Format("%4.2f", m_tAbsSpeed.GetLength()); };

		void			DrawVisibleArea(CDC* pDC, TScreenParams *tScreen);
		void			SetPlayerAbsCoordinates(TVector& pos, int dir, int headDir, double dSpeed
														, int iViewMode, BOOL bDashingBackward);
		void			UpdatePlayerCoordinates(int iDataAge, double dSpeed, BOOL bDashingBackward);
		TDirection	GetRelativeFromAbsolutePlayDirection(TDirection dir);
		TDirection	GetAngleTo(TVisibleObject* obj) { return GetAngleTo(obj->GetPosition());};
		TDirection	GetAngleTo(TVector& position);
		TDirection	GetAngleToBody(TVector& position);
		void			CheckVisuality(TVisibleObject* viewer, int iMaxAngle, int time);
		void			SetPushSpeed(double speed) { m_dPushSpeed = speed; };

	private:
		void	DrawTopView(CDC* pDC, TScreenParams *tScreen);
		void	DrawRelativeView(CDC* pDC, TScreenParams *tScreen);
		void	DrawAbsoluteView(CDC* pDC, TScreenParams *tScreen);
		void	DrawTime(CDC *pDC, TScreenParams* tScreen);
		void	CalculateAbsSpeed(double dSpeed, BOOL bDashingBackward);

		double	m_dPushSpeed;		// speed the player got by last dash
};

#endif // !defined(AFX_TTHISPLAYER_H__170267C1_E28F_11D2_A173_006008E88C8E__INCLUDED_)
