// TVector.h: interface for the TVector class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TVECTOR_H__4BFD2F81_C947_11D1_B242_0000C09B5CBE__INCLUDED_)
#define AFX_TVECTOR_H__4BFD2F81_C947_11D1_B242_0000C09B5CBE__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class TDirection;

class TVector : public CObject  
{
	public:
		TVector() { SetVector(0.0, 0.0); };
		TVector(double x, double y) { SetVector(x, y); };
		TVector(int x, int y) { SetVector((double) x, (double) y); };
		TVector(TVector &vec) { SetVector(vec); };
		virtual ~TVector();

		void		Rotate(int degrees);

		void		SetVector(double x, double y) { m_dX = x; m_dY = y; };
		void		SetVector(TVector& vec2) { m_dX = vec2.GetX(); m_dY = vec2.GetY(); };
		void		SetVectorByDirection(double len, int dir);
		void		SetX(double x) { m_dX = x; };
		void		SetY(double y) { m_dY = y; };
		double	GetX() const { return m_dX; };
		double	GetY() const { return m_dY; };
		TDirection	GetDirection() const;
		double	GetLength() const;

		TVector operator +(TVector& v2);
		TVector operator -(TVector& v2);
		TVector& operator +=(TVector& v2);
		TVector& operator -=(TVector& v2);
		TVector& operator *=(double val);
		TVector& operator =(TVector& vec2) { SetVector(vec2); return *this; };

		friend TVector operator* (double val1, TVector& val2);
		friend TVector operator* (TVector& val1, double val2);

#ifdef _DEBUG
	virtual void Dump(CDumpContext& dc) const;
#endif

	protected:

		double	m_dX;
		double	m_dY;
};

#endif // !defined(AFX_TVECTOR_H__4BFD2F81_C947_11D1_B242_0000C09B5CBE__INCLUDED_)
